/*
 * RageIRCd, an advanced Internet Relay Chat daemon (IRCd)
 * include/find.h: finding functions header file
 *
 * Copyright (C) 2002 the past and present IRCd developers, and others.
 * Refer to doc/authors/ for full credits and copyright details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * $Id: find.h,v 1.8 2004/02/18 20:14:11 rageircd Exp $
 */

#ifndef	__find_include__
#define __find_include__

#define find_server(a, b) hash_find_server(a, b)
#define find_client(a, b) hash_find_client(a, b)

#define find_target(x) (x ? (*x == '!' ? find_by_base64_id(x + 1) : hash_find_client(x, NULL)) : NULL)
#define find_target_chasing(z, x, q) (x ? (*x == '!' ? find_by_base64_id(x + 1) : find_chasing(z, x, NULL, q)) : NULL)
#define find_target_from(x, c) (x ? ((IsServer(c) && *x == '!') ? find_by_base64_id(x + 1) : hash_find_client(x, NULL)) : NULL)

static inline aClient *find_person(char *name, aClient *cptr)
{
	aClient *acptr = find_client(name, cptr);
	return acptr != NULL ? (IsClient(acptr) ? acptr : cptr) : cptr;
}

static inline aClient *find_person_target(char *name)
{
	aClient *acptr = find_target(name);
	return acptr != NULL ? (IsClient(acptr) ? acptr : NULL) : NULL;
}

static inline aClient *find_server_target(char *name)
{
	aClient *acptr = find_target(name);
	return acptr != NULL ? (IsServer(acptr) ? acptr : NULL) : NULL;
}

static inline aClient *find_person_on_server(char *name, char *server)
{
	aClient *acptr = find_client(name, NULL);

	if (acptr == NULL || !IsClient(acptr)) {
		return NULL;
	}
	if (!mycmp(server, acptr->uplink->name)) {
		return acptr;
	}
	return NULL;
}

#endif /* __find_include__ */
