/*
 * RageIRCd, an advanced Internet Relay Chat daemon (IRCd)
 * include/hash.h: hash header file
 *
 * Copyright (C) 2002 the past and present IRCd developers, and others.
 * Refer to doc/authors/ for full credits and copyright details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * $Id: hash.h,v 1.4 2004/02/01 01:23:52 rageircd Exp $
 */

#ifndef	__hash_include__
#define __hash_include__

typedef struct hashentry {
	int hits;
	int links;
	void *list;
} aHashEntry;

#define BITS_PER_COL 3
#define BITS_PER_COL_MASK 0x7
#define MAX_SUB (1 << BITS_PER_COL)

#define U_MAX_INITIAL 8192
#define U_MAX_INITIAL_MASK (U_MAX_INITIAL - 1)
#define U_MAX (U_MAX_INITIAL * MAX_SUB)

#define CH_MAX_INITIAL 2048
#define CH_MAX_INITIAL_MASK (CH_MAX_INITIAL - 1)
#define CH_MAX (CH_MAX_INITIAL * MAX_SUB)

#define WW_MAX_INITIAL 16
#define WW_MAX_INITIAL_MASK (WW_MAX_INITIAL - 1)
#define WW_MAX (WW_MAX_INITIAL * MAX_SUB)

#define WATCHHASHSIZE 10007

extern unsigned int hash_whowas_name(char *);

#endif /* __hash_include__ */
