/*
 * RageIRCd, an advanced Internet Relay Chat daemon (IRCd)
 * include/isupport.h: ISUPPORT/005 numeric tokens
 *
 * Copyright (C) 2002 the past and present IRCd developers, and others.
 * Refer to doc/authors/ for full credits and copyright details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * $Id: isupport.h,v 1.12 2004/04/06 22:10:31 rageircd Exp $
 */

#ifndef __isupport_include__
#define __isupport_include__

#include "conf2.h"
#include "xmode.h"

extern char isupport1[512];
extern char isupport2[512];
extern char isupport3[512];

#define ISUPPORT_PREFIX			"(ohv)@%+"

#define ISUPPORT_FEATURES1		"PREFIX=%s CHANTYPES=#& CHANMODES=%s MODES=%d " \
					"MAXCHANNELS=%d NICKLEN=%d TOPICLEN=%d KICKLEN=%d CHANNELLEN=%d MAXBANS=%d"
#define ISUPPORT_PARAMS1		ISUPPORT_PREFIX, chanmode_isupport, MAXMODEPARAMS, \
					GeneralConfig.max_chans_per_user, NICKLEN, TOPICLEN, TOPICLEN, CHANNELLEN, \
					MAXBANS

#define ISUPPORT_FEATURES2		"NETWORK=%s EXCEPTS=e INVEX=I SILENCE=%d WALLCHOPS CASEMAPPING=ascii " \
					"CHARSET=utf-8 MAXTARGETS=%d%s%s"
#define ISUPPORT_PARAMS2		NetworkConfig.name_005, MAXSILES, MAXTARGETS, \
					GeneralConfig.enable_knock ? " KNOCK" : "", \
					GeneralConfig.enable_map ? " MAP" : ""

#define ISUPPORT_FEATURES3		"WATCH=%d PRIVACY"
#define ISUPPORT_PARAMS3		MAXWATCH

#endif /* __isupport_include__ */
