/*
 * RageIRCd, an advanced Internet Relay Chat daemon (IRCd)
 * include/sys.h: system header file
 *
 * Copyright (C) 2002 the past and present IRCd developers, and others.
 * Refer to doc/authors/ for full credits and copyright details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * $Id: sys.h,v 1.19 2004/02/27 23:11:59 rageircd Exp $
 */

#ifndef	__sys_include__
#define __sys_include__

#include "setup.h"
#ifdef ISC202
#include <net/errno.h>
#else
#include <sys/errno.h>
#endif
#include <stdio.h>
#include <sys/types.h>
#include <sys/param.h>

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_LIMITS_H
#include <limits.h>
#endif

#ifdef HAVE_PARAM_H
#include <param.h>
#endif

#ifndef HAVE_INDEX
#define index strchr
#endif
#ifndef HAVE_RINDEX
#define rindex strrchr
#endif

#include <netinet/in.h>

#if ((__GNU_LIBRARY__ == 6) && (__GLIBC__ >=2) && (__GLIBC_MINOR__ >= 2))
#include <time.h>
#endif

#ifdef NO_U_TYPES
typedef unsigned char u_char;
typedef unsigned short u_short;
typedef unsigned long u_long;
typedef unsigned int u_int;
#endif

#endif /* __sys_include__ */
