/*
 * RageIRCd, an advanced Internet Relay Chat daemon (IRCd)
 * src/s_nuemric.c: numerics
 *
 * Copyright (C) 2002 the past and present IRCd developers, and others.
 * Refer to doc/authors/ for full credits and copyright details.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * $Id: s_numeric.c,v 1.6 2004/03/21 02:57:14 rageircd Exp $
 */

#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "channel.h"
#include "h.h"
#include "memory.h"

static char buf[1024];

int do_numeric(int numeric, aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	aClient *acptr;
	aChannel *chptr;
	char *nick, *p, numbuf[16];
	int i, len = 0;
	msg_ptr msg;

	if (parc < 1 || !IsServer(sptr)) {
		return 0;
	}
	if (numeric < 100) {
		numeric += 100;
	}

	ircsprintf(numbuf, "%d", numeric);
	msg.msg_str = numbuf;
	msg.tok_str = NULL;
	msg.flags = 0;

	buf[len] = '\0';
	if (parc > 1) {
		for (i = 2; i < (parc - 1); i++) {
			if (len > 0) {
				buf[len++] = ' ';
			}
			for (p = parv[i]; *p != '\0'; p++) {
				buf[len++] = *p;
			}
		}

		buf[len++] = ' ';
		buf[len++] = ':';

		for (p = parv[parc - 1]; *p != '\0'; p++) {
			buf[len++] = *p;
		}
		buf[len] = '\0';
	}
	for (p = NULL; (nick = strtoken(&p, parv[1], ",")) != NULL; parv[1] = NULL) {
		if ((acptr = find_target(nick)) != NULL) {
			if (!IsMe(acptr) && acptr->from != cptr) {
				sendto_one_client_prefixed_copy(acptr, sptr, &msg,
					PREFIX_NONE, buf);
			}
		}
		else if ((chptr = find_channel(nick, NULL)) != NULL) {
			sendto_channel_msg_butone_copy(cptr, sptr, chptr, chptr->chname,
				&msg, PREFIX_NONE, buf);
		}
	}
	return 0;
}
